<div class="user-form-div">
  <mat-grid-list cols="5" rowHeight="50px">
    <mat-grid-tile colspan='3'>
      <h1>User Form</h1>
    </mat-grid-tile>
    <mat-grid-tile colspan='2'>
      <button mat-raised-button mat-mini-fab color="primary" (click)="onBack()" class="back-button">
        <mat-icon>arrow_back</mat-icon>
      </button>
    </mat-grid-tile>
  </mat-grid-list>
  <div class="form-div">
    <form [formGroup]="userForm" (ngSubmit)="onSubmit()">
      <!-- Username -->
      <div>
        <label for="username">Username</label>
        <input id="username" class="form-control" formControlName="username" required />
        <div *ngIf="username.invalid && (username.dirty || username.touched)" class="alert alert-danger">
          <div *ngIf="username.errors?.required">Name is required.</div>
          <div *ngIf="username.errors?.minlength">
            Name must be at least 4 characters long.
          </div>
          <div *ngIf="username.errors?.unique">Username already exists.</div>
        </div>
      </div>

      <!-- Password -->
      <div>
        <label for="password">Password</label>
        <input id="password" type="password" class="form-control" (click) = 'onPasswordInputClicked()' formControlName="password" required />
        <div *ngIf="password.invalid && (password.dirty || password.touched)" class="alert alert-danger">
          <div *ngIf="password.errors?.required">Password is required.</div>
          <div *ngIf="password.errors?.minlength">
            Password must be at least 5 characters long.
          </div>
        </div>
      </div>

      <!-- Confirm Password -->
      <div>
        <label for="cpassword">Confirm Password</label>
        <input type="password" id="cpassword" class="form-control" (click) = 'onPasswordInputClicked()' formControlName="cpassword" required />
        <div *ngIf="cpassword.invalid && (cpassword.dirty || cpassword.touched)" class="alert alert-danger">
          <div *ngIf="cpassword.errors?.required">
            Confirm Password is required.
          </div>
        </div>
        <div *ngIf=" userForm.errors?.areEqual && (userForm.touched || userForm.dirty)"
          class="cross-validation-error-message alert alert-danger">
          Passwords has to be the same.
        </div>
      </div>

      <!-- First Name -->
      <div>
        <label for="fname">First Name</label>
        <input id="fname" class="form-control" formControlName="fname" required />
        <div *ngIf="fname.invalid && (fname.dirty || fname.touched)" class="alert alert-danger">
          <div *ngIf="fname.errors?.required">First Name is required.</div>
        </div>
      </div>

      <!-- Last Name -->
      <div>
        <label for="lname">Last Name</label>
        <input id="lname" class="form-control" formControlName="lname" required />
        <div *ngIf="lname.invalid && (lname.dirty || lname.touched)" class="alert alert-danger">
          <div *ngIf="lname.errors?.required">Last Name is required.</div>
        </div>
      </div>

      <!-- Eamil -->
      <div>
        <label for="email">Email</label>
        <input id="email" class="form-control" formControlName="email" required />
        <div *ngIf="email.invalid && (email.dirty || email.touched)" class="alert alert-danger">
          <div *ngIf="email.errors?.required">Email is required.</div>
          <div *ngIf="email.errors?.email">Invalide email format.</div>
        </div>
      </div>

      <!-- Phone -->
      <div>
        <label for="phone">Phone number</label>
        <input id="phone" class="form-control" formControlName="phone" required />
        <div *ngIf="phone.invalid && (phone.dirty || phone.touched)" class="alert alert-danger">
          <div *ngIf="phone.errors?.required">Phone number is required.</div>
          <div *ngIf="phone.errors?.pattern">Phone number must contains 10 digits.</div>
        </div>
      </div>

      <!-- <p>Form Status: {{ userForm.status }}</p> -->

      <button type="submit" mat-raised-button color="primary" [disabled]="!userForm.valid">
        {{ submitButtonText }}
      </button>
    </form>
  </div>
</div>